unit RefreshReportAfterDataChangeRAP;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, daSQLBuilder, ppCtrls, ppPrnabl, ppClass, daDataView,
  daQueryDataView, daDBBDE, ppModule, daDataModule, ppBands, ppCache,
  ppComm, ppRelatv, ppProd, ppReport, ppDevice, StdCtrls, raFunc, raCodMod, ppRTTI,
  ppParameter;

type
  TForm1 = class(TForm)
    ppReport1: TppReport;
    Button1: TButton;
    ppParameterList1: TppParameterList;
    ppHeaderBand1: TppHeaderBand;
    ppLabel1: TppLabel;
    ppDetailBand1: TppDetailBand;
    ppDBText1: TppDBText;
    ppFooterBand1: TppFooterBand;
    raCodeModule1: TraCodeModule;
    daDataModule1: TdaDataModule;
    daBDEQueryDataView1: TdaBDEQueryDataView;
//    procedure ppLabel1DrawCommandClick(Sender, aDrawCommand: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TmyResetFunction = class (TraSystemFunction)
  private
  public
    procedure ExecuteFunction(aParams: TraParamList); override;
    class function IsFunction: Boolean;
    class function GetSignature: String; override;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//procedure TForm1.ppLabel1DrawCommandClick(Sender, aDrawCommand: TObject);
//var
  //lSQLBuilder: TdaSQLBuilder;
//begin

 { lSQLBuilder := TdaSQLBuilder.Create(ppReport1);

  lSQLBuilder.OrderByFields.Items[0].Ascending := True;

  lSQLBuilder.ApplyUpdates;

  lSQLBuilder.Free;

  ppReport1.Reset;
  ppReport1.Engine.Reset;

  TppDrawCommand(aDrawCommand).RedrawPage := True;
  }
//end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ppReport1.Print;
end;

{------------------------------------------------------------------------------}
{ TmyResetFunction.GetSignature }

class function TmyResetFunction.GetSignature: String;
begin
  Result := 'procedure Reset(aReport: TppReport; aDrawCommand: TppDrawCommand);';
end; {class function, GetSignature}

{------------------------------------------------------------------------------}
{ TmyResetFunction.IsFunction }

class function TmyResetFunction.IsFunction: Boolean;
begin
  Result := False;
end;

{------------------------------------------------------------------------------}
{ TmyResetFunction.ExecuteFunction }

procedure TmyResetFunction.ExecuteFunction(aParams: TraParamList);
var
  lReport: TppReport;
  lDrawCommand: TppDrawCommand;
begin

  GetParamValue(0, lReport);
  GetParamValue(1, lDrawCommand);

  lReport.Reset;
  lReport.Engine.Reset;

  lDrawCommand.RedrawPage := True;

end; {procedure, ExecuteFunction}


initialization
  raRegisterFunction('Reset', TmyResetFunction);

finalization
  raUnRegisterFunction('Reset');

end.
